const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Client_ordersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const client_orders = await db.client_orders.create(
      {
        id: data.id || undefined,

        status: data.status || null,
        order_name: data.order_name || null,
        order_number: data.order_number || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await client_orders.setAssets(data.assets || [], {
      transaction,
    });

    return client_orders;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const client_ordersData = data.map((item, index) => ({
      id: item.id || undefined,

      status: item.status || null,
      order_name: item.order_name || null,
      order_number: item.order_number || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const client_orders = await db.client_orders.bulkCreate(client_ordersData, {
      transaction,
    });

    // For each item created, replace relation files

    return client_orders;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const client_orders = await db.client_orders.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.order_name !== undefined)
      updatePayload.order_name = data.order_name;

    if (data.order_number !== undefined)
      updatePayload.order_number = data.order_number;

    updatePayload.updatedById = currentUser.id;

    await client_orders.update(updatePayload, { transaction });

    if (data.assets !== undefined) {
      await client_orders.setAssets(data.assets, { transaction });
    }

    return client_orders;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const client_orders = await db.client_orders.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of client_orders) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of client_orders) {
        await record.destroy({ transaction });
      }
    });

    return client_orders;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const client_orders = await db.client_orders.findByPk(id, options);

    await client_orders.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await client_orders.destroy({
      transaction,
    });

    return client_orders;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const client_orders = await db.client_orders.findOne(
      { where },
      { transaction },
    );

    if (!client_orders) {
      return client_orders;
    }

    const output = client_orders.get({ plain: true });

    output.assets = await client_orders.getAssets({
      transaction,
    });

    return output;
  }

  static async findAll(filter, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.client_dam,
        as: 'assets',
        required: false,
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.status) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('client_orders', 'status', filter.status),
        };
      }

      if (filter.order_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'client_orders',
            'order_name',
            filter.order_name,
          ),
        };
      }

      if (filter.order_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'client_orders',
            'order_number',
            filter.order_number,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.assets) {
        const searchTerms = filter.assets.split('|');

        include = [
          {
            model: db.client_dam,
            as: 'assets_filter',
            required: searchTerms.length > 0,
            where:
              searchTerms.length > 0
                ? {
                    [Op.or]: [
                      {
                        id: {
                          [Op.in]: searchTerms.map((term) => Utils.uuid(term)),
                        },
                      },
                      {
                        id: {
                          [Op.or]: searchTerms.map((term) => ({
                            [Op.iLike]: `%${term}%`,
                          })),
                        },
                      },
                    ],
                  }
                : undefined,
          },
          ...include,
        ];
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.client_orders.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(query, limit, offset) {
    let where = {};

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('client_orders', 'id', query),
        ],
      };
    }

    const records = await db.client_orders.findAll({
      attributes: ['id', 'id'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['id', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.id,
    }));
  }
};
